net.sf.saxon.pattern

## Class CombinedNodeTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.CombinedNodeTest

- All Implemented Interfaces:
    Serializable, ItemType

      public class CombinedNodeTest
      extends NodeTest

  A CombinedNodeTest combines two nodetests using one of the operators union (=or), intersect (=and), difference (= "and not"). This arises when optimizing a union (etc) of two path expressions using the same axis. A CombinedNodeTest is also used to support constructs such as element(N,T), which can be expressed as (element(N,*) AND element(*,T))
  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CombinedNodeTest(NodeTest nt1, int operator, NodeTest nt2)` Create a NodeTest that combines two other node tests

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object other)` Indicates whether some other object is "equal to" this one.
    `AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
    `NodeTest[]` | `getComponentNodeTests()` Get the two parts of the combined node test
    `SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
    `double` | `getDefaultPriority()` Get the default priority of this nodeTest when used as a pattern.
    `int` | `getFingerprint()` Get the name of the nodes matched by this nodetest, if it matches a specific name.
    `int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
    `int` | `getOperator()` Get the operator used to combine the two node tests: one of `Token.UNION`, `Token.INTERSECT`, `Token.EXCEPT`,
    `int` | `getPrimitiveType()` Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
    `IntSet` | `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
    `ItemType` | `getSuperType(TypeHierarchy th)` Get the supertype of this type.
    `int` | `hashCode()` Returns a hash code value for the object.
    `boolean` | `isAtomizable()` Ask whether values of this type are atomizable
    `boolean` | `isNillable()` Determine whether the content type (if present) is nillable
    `boolean` | `matches(int nodeKind, NodeName name, int annotation)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
    `String` | `toString()`
    `void` | `visitNamedSchemaComponents(SchemaComponentVisitor visitor)` Visit all the schema components used in this ItemType definition

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `getPrimitiveItemType, isAtomicType, isPlainType, matches, matchesItem`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### CombinedNodeTest

          public CombinedNodeTest(NodeTest nt1,
                          int operator,
                          NodeTest nt2)

      Create a NodeTest that combines two other node tests
      Parameters:
        `nt1` - the first operand. Note that if the defaultPriority of the pattern is required, it will be taken from that of the first operand.
        `operator` - one of Token.UNION, Token.INTERSECT, Token.EXCEPT
        `nt2` - the second operand

  - ### Method Detail

    - #### matches

          public boolean matches(int nodeKind,
                        NodeName name,
                        int annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node tst

    - #### matches

          public boolean matches(TinyTree tree,
                        int nodeNr)

      Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `tree` - the TinyTree containing the node
        `nodeNr` - the number of the node within the TinyTree
      Returns:
        true if the node matches the NodeTest, otherwise false

    - #### matches

          public boolean matches(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getSuperType

          public ItemType getSuperType(TypeHierarchy th)

      Get the supertype of this type. This isn't actually a well-defined concept: the types form a lattice rather than a strict hierarchy.
      Specified by:
        `getSuperType` in interface `ItemType`
      Overrides:
        `getSuperType` in class `NodeTest`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the supertype, or null if this type is item()

    - #### getNodeKindMask

          public int getNodeKindMask()

      Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<<Type.ELEMENT for element nodes, 1<<Type.TEXT for text nodes, and so on.
      Overrides:
        `getNodeKindMask` in class `NodeTest`
      Returns:
        a combination of bits: 1<

    - #### getPrimitiveType

          public int getPrimitiveType()

      Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the node kind matched by this node test

    - #### getRequiredNodeNames

          public IntSet getRequiredNodeNames()

      Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name). The default implementation returns null.
      Overrides:
        `getRequiredNodeNames` in class `NodeTest`
      Returns:
        the set of integer fingerprints of the node names that this node test can match.

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `NodeTest`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable()

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Overrides:
        `isAtomizable` in class `NodeTest`
      Returns:
        true unless it is known that these items will be elements with element-only content, in which case return false

    - #### getFingerprint

          public int getFingerprint()

      Get the name of the nodes matched by this nodetest, if it matches a specific name. Return -1 if the node test matches nodes of more than one name
      Overrides:
        `getFingerprint` in class `NodeTest`

    - #### isNillable

          public boolean isNillable()

      Determine whether the content type (if present) is nillable
      Overrides:
        `isNillable` in class `NodeTest`
      Returns:
        true if the content test (when present) can match nodes that are nilled

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object other)

      Indicates whether some other object is "equal to" this one.
      Overrides:
        `equals` in class `Object`

    - #### getDefaultPriority

          public double getDefaultPriority()

      Get the default priority of this nodeTest when used as a pattern. In the case of a union, this will always be (arbitrarily) the default priority of the first operand. In other cases, again somewhat arbitrarily, it is 0.25, reflecting the common usage of an intersection to represent the pattern element(E, T).
      Returns:
        the default priority

    - #### getComponentNodeTests

          public NodeTest[] getComponentNodeTests()

      Get the two parts of the combined node test
      Returns:
        the two operands

    - #### getOperator

          public int getOperator()

      Get the operator used to combine the two node tests: one of `Token.UNION`, `Token.INTERSECT`, `Token.EXCEPT`,
      Returns:
        the operator

    - #### visitNamedSchemaComponents

          public void visitNamedSchemaComponents(SchemaComponentVisitor visitor)
                                          throws XPathException

      Visit all the schema components used in this ItemType definition
      Specified by:
        `visitNamedSchemaComponents` in interface `ItemType`
      Overrides:
        `visitNamedSchemaComponents` in class `NodeTest`
      Parameters:
        `visitor` - the visitor class to be called when each component is visited
      Throws:
        `XPathException` - if an error occurs

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.